import { Module } from '@nestjs/common';
import { TypeOrmModule } from '@nestjs/typeorm';
import { Card } from './entities';
import { Account } from './entities/account.entity';
import { Transaction } from './entities/transaction.entity';
import { CardRepository } from './repositories';
import { AccountRepository } from './repositories/account.repository';
import { TransactionRepository } from './repositories/transaction.repository';
import { CardService } from './services';
import { AccountService } from './services/account.service';
import { TransactionService } from './services/transaction.service';

@Module({
  imports: [TypeOrmModule.forFeature([Card, Account, Transaction])],
  providers: [
    CardService,
    CardRepository,
    TransactionService,
    TransactionRepository,
    AccountService,
    AccountRepository,
  ],
  exports: [CardService, TransactionService],
})
export class CardModule {}
