import { Body, Controller, Post } from '@nestjs/common';
import { ApiTags } from '@nestjs/swagger';
import { TransactionService } from '~/card/services/transaction.service';
import { AccountTransactionWebhookRequest, CardTransactionWebhookRequest } from '../dtos/requests';

@Controller('neoleap-webhooks')
@ApiTags('Neoleap Webhooks')
export class NeoLeapWebhooksController {
  constructor(private readonly transactionService: TransactionService) {}

  @Post('card-transaction')
  async handleCardTransactionWebhook(@Body() body: CardTransactionWebhookRequest) {
    return this.transactionService.createCardTransaction(body);
  }

  @Post('account-transaction')
  async handleAccountTransactionWebhook(@Body() body: AccountTransactionWebhookRequest) {
    return this.transactionService.createAccountTransaction(body);
  }
}
