import { ApiProperty } from '@nestjs/swagger';
import { Expose, Transform } from 'class-transformer';
import { InquireApplicationResponse } from './inquire-application.response';

export class CreateApplicationResponse extends InquireApplicationResponse {
  @Transform(({ obj }) => obj.CardDetailsList?.[0]?.ResponseCardIdentifier.Id.toString())
  @Expose()
  @ApiProperty()
  cardId!: string;

  @Transform(({ obj }) => obj.CardDetailsList?.[0]?.ResponseCardIdentifier.VPan)
  @Expose()
  @ApiProperty()
  vpan!: string;

  @Transform(({ obj }) => obj.CardDetailsList?.[0]?.ExpiryDate)
  @Expose()
  @ApiProperty()
  expiryDate!: string;

  @Transform(({ obj }) => obj.CardDetailsList?.[0]?.CardStatus)
  @Expose()
  @ApiProperty()
  cardStatus!: string;

  @Transform(({ obj }) => obj.CardDetailsList?.[0]?.ResponseCardIdentifier?.MaskedPan?.split('_')[0])
  @Expose()
  @ApiProperty()
  firstSixDigits!: string;

  @Transform(({ obj }) => obj.CardDetailsList?.[0]?.ResponseCardIdentifier?.MaskedPan?.split('_')[1])
  @Expose()
  @ApiProperty()
  lastFourDigits!: string;

  @Transform(({ obj }) => obj.AccountDetailsList?.[0]?.Id.toString())
  @Expose()
  @ApiProperty()
  accountId!: string;
}
