import { INeoleapHeaderRequest } from './neoleap-header.request.interface';

export interface ICreateApplicationRequest extends INeoleapHeaderRequest {
  CreateNewApplicationRequestDetails: {
    ApplicationRequestDetails: {
      InstitutionCode: string;
      ExternalApplicationNumber: string;
      ApplicationType: string;
      Product: string;
      ApplicationDate: string;
      BranchCode: '000';
      ApplicationSource: 'O';
      DeliveryMethod: 'V';
    };
    ApplicationProcessingDetails: {
      ProcessControl: string;
      RequestedLimit: number;
      SuggestedLimit: number;
      AssignedLimit: number;
    };

    ApplicationFinancialInformation: {
      Currency: {
        AlphaCode: 'SAR';
      };
      BillingCycle: 'C1';
    };

    ApplicationOtherInfo: object;

    ApplicationCustomerDetails: {
      Title: string;
      FirstName: string;
      LastName: string;
      FullName: string;
      EmbossName: string;
      DateOfBirth: string;
      LocalizedDateOfBirth: string;
      Gender: string;
      Nationality: string;
      IdType: string;
      IdNumber: string;
      IdExpiryDate: string;
    };

    ApplicationAddress: {
      AddressLine1: string;
      AddressLine2: string;
      City: string;
      Region: string;
      Country: string;
      CountryDetails: {
        DefaultCurrency: {};
        Description: [];
      };
      Phone1: string;
      Email: string;
      AddressRole: number;
    };
  };
}
